package com.wtkj.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springblade.core.mp.base.BaseEntity;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author Blizzard
 * @create at 2023-10-12 15:12
 * @describe
 */
@EqualsAndHashCode(callSuper = true)
@TableName("blade_task_contract_pay_log")
@Data
public class TaskContractPayLog extends BaseEntity {

	private static final long serialVersionUID = 1L;

	@TableField("contract_id")
	@JsonSerialize(using = ToStringSerializer.class)
	@NotNull(message = "contractId can't be null")
	private Long contractId;

	@TableField("pay_amount")
	private BigDecimal payAmount = BigDecimal.valueOf(0);

	@TableField("pay_time")
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd")
	private Date payTime;

	@TableField("blade_file_ids")
	private String bladeFileIds;
}
